. /etc/functions.sh

libdir=/usr/lib/webif
wwwdir=/www
cgidir=/www/cgi-bin/webif
rootdir=/cgi-bin/webif
indexpage=index.sh

# workarounds for stupid busybox slowness on [ ]
empty() {
	case "$1" in
		"") return 0 ;;
		*) return 255 ;;
	esac
}
equal() {
	case "$1" in
		"$2") return 0 ;;
		*) return 255 ;;
	esac
}
neq() {
	case "$1" in
		"$2") return 255 ;;
		*) return 0 ;;
	esac
}
# very crazy, but also very fast :-)
exists() {
	( < $1 ) 2>&-
}

categories() {
	grep '##WEBIF:' $cgidir/.categories $cgidir/*.sh 2>/dev/null | \
		awk -v "selected=$1" \
			${HEADER_PLAIN:+-v plain=1} \
			-v "rootdir=$rootdir" \
			-v "indexpage=$indexpage" \
			-v "path=$PATH_INFO" \
			-f /usr/lib/webif/categories.awk -
}

header() {
	local title="$1"

	empty "$ERROR" && {
		_saved_title="${SAVED:+: @TR<<Settings saved>>}"
	} || {
		FORM_submit="";
		ERROR="<h3>$ERROR</h3><br /><br />"
		_saved_title=": @TR<<Error>>"
	}
	cat <<EOF
Content-Type: text/html
Pragma: no-cache

<?xml version="1.0" encoding="@TR<<Encoding|ISO-8859-1>>"?>
<html>
	<head>
		<title>FON Router GUI</title>
		<link rel="stylesheet" href="/style.css" type="text/css">
		<meta http-equiv="Content-Type" content="text/html; charset=@TR<<Encoding|ISO-8859-1>>" />
		<meta name="author" content="FON Wireless">
	</head>
	<body>

	<script type="text/javascript" src="/webif.js "></script>
	<script type="text/javascript" language="JavaScript">
function submitform(){
  document.myform.submit();
}
	</script>

	<center>
	<table width="80%" BORDER="0" CELLPADDING="0" CELLSPACING="0" >
			<tr>
				<td  background="/images/table/left.gif" valign="top"><img src="/images/table/top-left.gif" width="38" height="82"></td>
			  <td rowspan="2" valign="top" width="177">
				<!--NAVIGATION-->
			  <div id="sidebar">
				<table width="100%" border="0" CELLPADDING="0" CELLSPACING="0">
					<tr>
						<td rowspan="2" width="167" height="175"><IMG SRC="/images/table/logo.gif">
							<!--NAVIGATION BUTTONS-->
							<table>
								<tr><td>
								<div class="button_orange" style="float: left;">
									<div class="btnleft"></div>
									<a href="/cgi-bin/status.sh"></a>
									<div class="btncenter">
									<a href="/cgi-bin/status.sh">@TR<<Status>></a>
									</div>
									<div class="btnright"></div>
								</div>
								</td></tr>
								<tr><td>
								<div class="button_orange" style="float: left;">
									<div class="btnleft"></div>
									<a href="/cgi-bin/webif/public.sh"></a>
									<div class="btncenter">
									<a href="/cgi-bin/webif/public.sh">@TR<<Public WiFi>></a>
									</div>
									<div class="btnright"></div>
								</div>
								</td></tr>
								<tr><td>
								<div class="button_orange" style="float: left;">
									<div class="btnleft"></div>
									<a href="/cgi-bin/webif/private.sh"></a>
									<div class="btncenter">
									<a href="/cgi-bin/webif/private.sh">@TR<<Private WiFi>></a>
									</div>
									<div class="btnright"></div>
								</div>
								</td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
									<div class="btnleft"></div>
									<a href="/cgi-bin/webif/password.sh"></a>
									<div class="btncenter">
									<a href="/cgi-bin/webif/password.sh">@TR<<Password>></a>
									</div>
									<div class="btnright"></div>
								</div>
								</td></tr>
								<tr><td>
                                                                        <div class="button_orange" style="float: left;">
                                                                        <div class="btnleft"></div>
                                                                        <a href="/cgi-bin/webif/language.sh"></a>
                                                                        <div class="btncenter">
                                                                        <a href="/cgi-bin/webif/language.sh">@TR<<Language>></a>
                                                                        </div>
                                                                        <div class="btnright"></div>
                                                                </div>
                                                                </td></tr>
								<tr><td>
									<div class="button_orange" style="float: left;">
									<div class="btnleft"></div>
									<a href="/cgi-bin/webif/connection.sh"></a>
									<div class="btncenter">
									<a href="/cgi-bin/webif/connection.sh">@TR<<Advanced>></a>
									</div>
									<div class="btnright"></div>
								</div>
								</td></tr>
								$ADV_SUBMENU
							</table>
							<br />
							<br />
						</td>

						<td style="background: transparent url(/images/table/top.gif) repeat-x;" width="10"></td>

					</tr>
					<tr>
						<td background="/images/table/sidebar.gif"></td>
					</tr>
			  </table>
			  </td>
				<td style="background: transparent url(/images/table/top.gif) repeat-x;" colspan="2" height="82">
					<!--BEGIN MENU CODE-->
					<table width="100%"><tr>
						<td>
							<h1><br/>@TR<<$title>>$_saved_title</h1>
						</td>
						<td align="right">
						</td>
					</tr></table>
					<!--END MENU CODE-->
				</td>
				<td  background="/images/table/right.gif" valign="top">
				<img src="/images/table/top-right.gif" width="38" height="82"></td>
			</tr>
			<tr>
				<td background="/images/table/left.gif" width="38"> </td>
				<td colspan="2" valign="top" style="background: transparent url(/images/Fonera.gif); background-position: 100% 100%; background-repeat: no-repeat; " >
				<form method="post" action="$SCRIPT_NAME" enctype="multipart/form-data">
				<br />
				<br />
				$ERROR
EOF
}

footer() {
	cat <<EOF
				<br />
				<br />
				</form>
				<!--td valign="bottom" width="150">
					<img src="/images/Fonera.gif" width="150" height="200">
				</td-->
				</td>
				<td background="/images/table/right.gif" width="38"></td>
			</tr>


			<tr>
			<td>
			<img src="/images/table/bottom-left.gif" width="38" height="39"></td>
			<td align="center" background="/images/table/bottom.gif" height="39" colspan="3"> </td>
			<td>
			<img src="/images/table/bottom-right.gif" width="38" height="39"></td>
			</tr>
	</table>
<br />

</center>
</body>
</html>
EOF
}

display_form() {
	awk -F'|' -f /usr/lib/webif/form.awk
}


load_settings() {
	config_load "$1"
	exists /tmp/.webif/config-$1 && . /tmp/.webif/config-$1
}

validate() {
	eval "$(awk -f /usr/lib/webif/validate.awk)"
}

save_setting() {
	mkdir -p /tmp/.webif
	cat >> /tmp/.webif/config-$1 <<EOF
config update "$2"
	option "$3" "$4"
EOF
}

get_default() {
	eval "FORM_$1=\"\${FORM_$1:-\${CONFIG_${2}_${3}}}\""
}

commit_settings() {(
	reset_cb
	option_cb() {
		# FIXME: ';' cannot be used in any config values
		updatestr="${updatestr:+$updatestr;}$CONFIG_SECTION.$1=$2"
	}

	for cfg in /tmp/.webif/config-*; do
		exists $cfg || continue
		export cfgfile="${cfg##*config-}"
		export updatestr=
		. $cfg

		lock /tmp/.webif/update-$cfgfile
		awk \
			-v cfgfile="/etc/config/$cfgfile" \
			-v updatestr="$updatestr" \
			-f /usr/lib/webif/uci-update.awk \
			-f - > /etc/config/$cfgfile.new <<EOF
BEGIN {
	cfg = read_file(cfgfile)
	print update_config(cfg, updatestr)
}
EOF
		equal "$?" 0 && {
			mv /etc/config/$cfgfile.new /etc/config/$cfgfile
			rm -f /tmp/.webif/config-$cfgfile
		}
		lock -u /tmp/.webif/update-$cfgfile
	done
)}


