#!/bin/bash
# rootfs.squashfs creator by KaR]V[aN - GPL
OUTFILE=fon.rootfs.squashfs
TEMPFILE=.root.squashfs


echo "Squash root file system creator by KaR]V[aN - GPL"

[ -f $OUTFILE ] && rm $OUTFILE

if [ -f bin/mksquashfs-lzma ]; then
	echo "Creating Image - Step1"
	bin/mksquashfs-lzma fonera-0.7.1.1/* $TEMPFILE -nopad -noappend -root-owned -be 1>/dev/null 2>&1 3>&1
else
	echo "Cant find mksquashfs-lzma"
	exit
fi

echo "Creating Image - Step2"
dd if=$TEMPFILE of=$OUTFILE bs=128k conv=sync 1>/dev/null 2>&1 3>&1
rm $TEMPFILE

if [ $(ls -l $OUTFILE | awk '{print $5}') -gt 7274496 ]; then
	echo "Output file is bigger than flash memory, you should not use it."
	echo "Try to delete some stuff from the root file system."
fi
echo "Done: $OUTFILE"
